Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::PRCRev Class Reference

Perry's simple reverberator class. More...

`#include <PRCRev.h>`

Inheritance diagram for stk::PRCRev:

## Public Member Functions

| PRCRev (StkFloat T60=1.0)
| Class constructor taking a T60 decay time argument (one second default value).
void | clear (void)
| Reset and clear all internal state.
void | setT60 (StkFloat T60)
| Set the reverberation T60 decay time.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed stereo frame.
StkFloat | tick (StkFloat input, unsigned int channel=0)
| Input one sample to the effect and return the specified `channel` value of the computed stereo frame.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.
Public Member Functions inherited from stk::Effect
| Effect (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual void | setEffectMix (StkFloat mix)
| Set the mixture of input and "effected" levels in the output (0.0 = input only, 1.0 = effect only).
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members

Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

Perry's simple reverberator class.

This class takes a monophonic input signal and produces a stereo output signal. It is based on some of the famous Stanford/CCRMA reverbs (NRev, KipRev), which were based on the Chowning/Moorer/Schroeder reverberators using networks of simple allpass and comb delay filters. This class implements two series allpass units and two parallel comb filters.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ lastOut()

StkFloat stk::PRCRev::lastOut | ( | unsigned int | channel = 0 | ) |

inline

Return the specified channel value of the last computed stereo frame.

Use the lastFrame() function to get both values of the last computed stereo frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

91{
92#if defined(_STK_DEBUG_)
93 if ( channel > 1 ) {
94 oStream_ << "PRCRev::lastOut(): channel argument must be less than 2!";
95 handleError( StkError::FUNCTION_ARGUMENT );
96 }
97#endif
98
99 return lastFrame_[channel];
100}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [1/3]

StkFloat stk::PRCRev::tick | ( | StkFloat | input,
|  | unsigned int | channel = 0 )

inline

Input one sample to the effect and return the specified `channel` value of the computed stereo frame.

Use the lastFrame() function to get both values of the computed stereo output frame. The `channel` argument must be 0 or 1 (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

103{
104#if defined(_STK_DEBUG_)
105 if ( channel > 1 ) {
106 oStream_ << "PRCRev::tick(): channel argument must be less than 2!";
107 handleError( StkError::FUNCTION_ARGUMENT );
108 }
109#endif
110
111 StkFloat temp, temp0, temp1, temp2, temp3;
112
113 temp = allpassDelays_[0].lastOut();
114 temp0 = allpassCoefficient_ * temp;
115 temp0 += input;
116 allpassDelays_[0].tick(temp0);
117 temp0 = -(allpassCoefficient_ * temp0) + temp;
118
119 temp = allpassDelays_[1].lastOut();
120 temp1 = allpassCoefficient_ * temp;
121 temp1 += temp0;
122 allpassDelays_[1].tick(temp1);
123 temp1 = -(allpassCoefficient_ * temp1) + temp;
124
125 temp2 = temp1 + ( combCoefficient_[0] * combDelays_[0].lastOut() );
126 temp3 = temp1 + ( combCoefficient_[1] * combDelays_[1].lastOut() );
127
128 lastFrame_[0] = effectMix_ * (combDelays_[0].tick(temp2));
129 lastFrame_[1] = effectMix_ * (combDelays_[1].tick(temp3));
130 temp = (1.0 - effectMix_) * input;
131 lastFrame_[0] += temp;
132 lastFrame_[1] += temp;
133
134 return lastFrame_[channel];
135}

## ◆ tick() [2/3]

StkFrames & stk::PRCRev::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = 0 )

Take a channel of the StkFrames object as inputs to the effect and replace with stereo outputs.

The StkFrames argument reference is returned. The stereo outputs are written to the StkFrames argument starting at the specified `channel`. Therefore, the `channel` argument must be less than ( channels() - 1 ) of the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

## ◆ tick() [3/3]

StkFrames & stk::PRCRev::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = 0,
|  | unsigned int | oChannel = 0 )

Take a channel of the `iFrames` object as inputs to the effect and write stereo outputs to the `oFrames` object.

The `iFrames` object reference is returned. The `iChannel` argument must be less than the number of channels in the `iFrames` argument (the first channel is specified by 0). The `oChannel` argument must be less than ( channels() - 1 ) of the `oFrames` argument. However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

The documentation for this class was generated from the following file:

- PRCRev.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.